
// Updated: 31st May 2003

// This will cause various compile-time messages to be emitted. When you get
// sick of them just comment out or remove this #define
#define	_STLSOFT_COMPILE_VERBOSE

#include <stdio.h>

#include <unixstl_findfile_sequence.h>

unixstl_ns_using(findfile_sequence)

#include <algorithm>

unixstl_ns_using_std(for_each)

/* ////////////////////////////////////////////////////////////////////////// */

void print_file_name(char const *fileName)
{
	printf(" \"%s\"\n", fileName);
}

int main(int argc, char *argv[])
{
	char const	*pattern;

	if(argc < 2)
	{
		// This just allows easy testing on Win32.
#ifdef WIN32
		pattern = "*.*";
#else
		pattern = "*";
#endif /* WIN32 */
	}
	else
	{
		pattern = argv[1];
	}

	{
		printf("\nfindfile_sequence, without dots, unsorted\n");

		findfile_sequence	sequence(pattern, findfile_sequence::noSort);

		for_each(sequence.begin(), sequence.end(), print_file_name);
	}

	{
		printf("\nfindfile_sequence: with dots, directories only, directories marked, sorted, reverse iteration\n");

		findfile_sequence	sequence(pattern, findfile_sequence::includeDots |  findfile_sequence::onlyDir | findfile_sequence::markDirs);

		for_each(sequence.rbegin(), sequence.rend(), print_file_name);
	}

	{
		printf("\nfindfile_sequence: without dots, unsorted, accessed via indexing\n");

		findfile_sequence	sequence(pattern);

		for(findfile_sequence::size_type i = 0; i < sequence.size(); ++i)
		{
			if(i % 2)
			{ 
				printf(" %u: \"%s\"\n", i, sequence[i]);
			}
			else
			{
				printf(" %u: \"%s\"\n", i, const_cast<findfile_sequence const&>(sequence)[i]);
			}
		}
	}

	return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
